//****************************************************************************
//	CGrayDib.h header file.
//

#ifndef	__CGrayDib_H__
#define __CGrayDib_H__

typedef	struct	_PCXHeader
                 {
          BYTE	ZsoftSign;	/* Always = 10 for PaintBrush        */
		  BYTE	Version;	/* Info about version		     */
		  BYTE	GroupCoding;	/* Group coding ( = 1 )		     */
		  BYTE	BitPerPixel;	/* Bit per pixel		     */
		  WORD	X1;		/* Image size ( includ. )	     */
		  WORD	Y1;
		  WORD	X2;
		  WORD	Y2;
		  WORD	HResolution;	/* Horisontal display resolution     */
		  WORD	VResolution;	/* Vertical display resolution	     */
		  BYTE	EGAPalette[ 48 ];	/* Palette		     */
		  BYTE	VideoMode;	/* Ignoring			     */
		  BYTE	PlanesNumber;	/* Planes number ( ver.2.5 = 0 )     */	
		  WORD	BytePerLine;	/* Byte per line		     */
		  WORD	PaletteInfo;	/* Palette info (2 = gray,1 = color) */
		  WORD	SHResolution;	/* Scanner horisontal resolution     */
		  WORD	SVResolution;	/* Scanner vertical resolution	     */
		  BYTE	Reserve[ 54 ];	/* Reserved			     */
		 } PCXHeader;

//****************************************************************************
//	Classes

class CGrayDib
{
public:
	HGLOBAL	m_hDib;
	DWORD	m_dwWidth;
	DWORD	m_dwHeight;
	DWORD	m_dwRowLength;
	DWORD	m_dwDibLength;

public:
	CGrayDib( void );
	~CGrayDib( void );

	BOOL IsValidGrayDib ();

	BOOL	Create( CSize szSize );
	BOOL	Create( HGLOBAL hHandle );
	BOOL	Create( CSize szSize, BYTE clrColor );
	BOOL	Create( BYTE *pBuffer, int sizeX, int sizeY );
	BYTE*	CreateBuffer();

	HGLOBAL	GetHandle();
	BOOL	ReplaceHandle( HGLOBAL hHandle );
	BOOL	CopyHandle( HGLOBAL hHandle );
	HGLOBAL CopyHGlobal( HGLOBAL hHandle );

	PBYTE	LockBits();
	BOOL	UnlockBits();

	CGrayDib*	ZoomIn( CSize szSize );
	CGrayDib*	ZoomX_Out( DWORD	new_pix );
	CGrayDib*	ZoomY_Out( DWORD new_row );
	CGrayDib*	Zoom ( CSize szNewSize );

	CSize	GetSize();
	int		Width();
	int		Height();
	int		RowLength();
	int		Length();

	BOOL	Revert ();
	BOOL	Fill( BYTE clrColor );
	BOOL	Paste( CGrayDib* pdPasteDib, CPoint ptPoint );

	void	operator=( CGrayDib dDib );
	BOOL	Draw( CDC* pDC, CRect rect );

	BOOL	LoadDibFromResource ( LPCTSTR lpName, LPCTSTR lpType );
	BOOL	LoadDibFromBmpFile(CFile& file);
	BOOL	LoadDibFromBmpFile( CString strFileName );

	BOOL	LoadDibFromPcxFile( CString strFileName );
	BOOL	LoadDibFromPcxFile(CFile& file);

	BOOL	SaveDibToBmpFile(CFile& file);
	BOOL	SaveDibToBmpFile( CString strFileName );

	BOOL	GetBitmapInfoHeader ( LPBITMAPINFOHEADER lpbi );

	BOOL	DrawWithoutStretch( CDC* pDC, CPoint Point );
//	BOOL	DrawWithoutStretch( CDC* pDC, CRect rRect );
	BOOL	Stretch( CDC* pDC, CRect rRect );

// Palette
	void SetGrayPalette ();
	void InvertPalette ();

// Middle
	BYTE CalculateMiddle();
	BOOL Center ( BYTE bDestMiddle );

protected:
	DWORD	AlignToDword( DWORD dwValue );
};

class C256Palette
{
public:
	BYTE m_btPalette [1024];
	
public:
	C256Palette ()
	{
	}
	~C256Palette ()
	{
	}

	BOOL Create ( CGrayDib *pDib )
	{
		if ( !pDib || !pDib -> m_hDib )
			return FALSE;

		BYTE *pBits = pDib -> LockBits () - 1024;

		memcpy ( m_btPalette, pBits, 1024 );
		
		pDib -> UnlockBits ();

		return TRUE;
	}

	BOOL SetToDib ( CGrayDib *pDib )
	{
		if ( !pDib || !pDib -> m_hDib )
			return FALSE;

		BYTE *pBits = pDib -> LockBits () - 1024;

		memcpy ( pBits, m_btPalette, 1024 );
		
		pDib -> UnlockBits ();

		return TRUE;
	}
};

#endif	//	CGrayDib_H_

//****************************************************************************
//	End of CGrayDib.h file
